diff --git a/src/backend/nodes/copyfuncs.c b/src/backend/nodes/copyfuncs.c
index 3432bb921dd..c862e8726fa 100644
--- a/src/backend/nodes/copyfuncs.c
+++ b/src/backend/nodes/copyfuncs.c
@@ -901,7 +901,15 @@ _copyHashJoin(const HashJoin *from)
 	COPY_NODE_FIELD(hashclauses);
 	COPY_NODE_FIELD(hashoperators);
 	COPY_NODE_FIELD(hashcollations);
-	COPY_NODE_FIELD(hashkeys);
+	COPY_NODE_FIELD(hashkeys_outer);
+	COPY_NODE_FIELD(hashkeys_inner);
+
+	COPY_SCALAR_FIELD(skewTable);
+	COPY_SCALAR_FIELD(skewColumn);
+	COPY_SCALAR_FIELD(skewInherit);
+	COPY_SCALAR_FIELD(inner_rows_total);
+
+	COPY_NODE_FIELD(inner_tlist);
 
 	return newnode;
 }
@@ -1053,31 +1061,6 @@ _copyUnique(const Unique *from)
 	return newnode;
 }
 
-/*
- * _copyHash
- */
-static Hash *
-_copyHash(const Hash *from)
-{
-	Hash	   *newnode = makeNode(Hash);
-
-	/*
-	 * copy node superclass fields
-	 */
-	CopyPlanFields((const Plan *) from, (Plan *) newnode);
-
-	/*
-	 * copy remainder of node
-	 */
-	COPY_NODE_FIELD(hashkeys);
-	COPY_SCALAR_FIELD(skewTable);
-	COPY_SCALAR_FIELD(skewColumn);
-	COPY_SCALAR_FIELD(skewInherit);
-	COPY_SCALAR_FIELD(rows_total);
-
-	return newnode;
-}
-
 /*
  * _copySetOp
  */
@@ -4886,9 +4869,6 @@ copyObjectImpl(const void *from)
 		case T_Unique:
 			retval = _copyUnique(from);
 			break;
-		case T_Hash:
-			retval = _copyHash(from);
-			break;
 		case T_SetOp:
 			retval = _copySetOp(from);
 			break;
diff --git a/src/backend/nodes/outfuncs.c b/src/backend/nodes/outfuncs.c
index b0dcd02ff68..56ce5abea4f 100644
--- a/src/backend/nodes/outfuncs.c
+++ b/src/backend/nodes/outfuncs.c
@@ -763,7 +763,15 @@ _outHashJoin(StringInfo str, const HashJoin *node)
 	WRITE_NODE_FIELD(hashclauses);
 	WRITE_NODE_FIELD(hashoperators);
 	WRITE_NODE_FIELD(hashcollations);
-	WRITE_NODE_FIELD(hashkeys);
+	WRITE_NODE_FIELD(hashkeys_outer);
+	WRITE_NODE_FIELD(hashkeys_inner);
+
+	WRITE_OID_FIELD(skewTable);
+	WRITE_INT_FIELD(skewColumn);
+	WRITE_BOOL_FIELD(skewInherit);
+	WRITE_FLOAT_FIELD(inner_rows_total, "%.0f");
+
+	WRITE_NODE_FIELD(inner_tlist);
 }
 
 static void
@@ -859,20 +867,6 @@ _outUnique(StringInfo str, const Unique *node)
 	WRITE_OID_ARRAY(uniqCollations, node->numCols);
 }
 
-static void
-_outHash(StringInfo str, const Hash *node)
-{
-	WRITE_NODE_TYPE("HASH");
-
-	_outPlanInfo(str, (const Plan *) node);
-
-	WRITE_NODE_FIELD(hashkeys);
-	WRITE_OID_FIELD(skewTable);
-	WRITE_INT_FIELD(skewColumn);
-	WRITE_BOOL_FIELD(skewInherit);
-	WRITE_FLOAT_FIELD(rows_total, "%.0f");
-}
-
 static void
 _outSetOp(StringInfo str, const SetOp *node)
 {
@@ -3774,9 +3768,6 @@ outNode(StringInfo str, const void *obj)
 			case T_Unique:
 				_outUnique(str, obj);
 				break;
-			case T_Hash:
-				_outHash(str, obj);
-				break;
 			case T_SetOp:
 				_outSetOp(str, obj);
 				break;
diff --git a/src/backend/nodes/readfuncs.c b/src/backend/nodes/readfuncs.c
index 764e3bb90c9..07adfde0212 100644
--- a/src/backend/nodes/readfuncs.c
+++ b/src/backend/nodes/readfuncs.c
@@ -2098,7 +2098,14 @@ _readHashJoin(void)
 	READ_NODE_FIELD(hashclauses);
 	READ_NODE_FIELD(hashoperators);
 	READ_NODE_FIELD(hashcollations);
-	READ_NODE_FIELD(hashkeys);
+	READ_NODE_FIELD(hashkeys_outer);
+	READ_NODE_FIELD(hashkeys_inner);
+	READ_OID_FIELD(skewTable);
+	READ_INT_FIELD(skewColumn);
+	READ_BOOL_FIELD(skewInherit);
+	READ_FLOAT_FIELD(inner_rows_total);
+
+	READ_NODE_FIELD(inner_tlist);
 
 	READ_DONE();
 }
@@ -2267,25 +2274,6 @@ _readGatherMerge(void)
 	READ_DONE();
 }
 
-/*
- * _readHash
- */
-static Hash *
-_readHash(void)
-{
-	READ_LOCALS(Hash);
-
-	ReadCommonPlan(&local_node->plan);
-
-	READ_NODE_FIELD(hashkeys);
-	READ_OID_FIELD(skewTable);
-	READ_INT_FIELD(skewColumn);
-	READ_BOOL_FIELD(skewInherit);
-	READ_FLOAT_FIELD(rows_total);
-
-	READ_DONE();
-}
-
 /*
  * _readSetOp
  */
@@ -2777,8 +2765,6 @@ parseNodeString(void)
 		return_value = _readGather();
 	else if (MATCH("GATHERMERGE", 11))
 		return_value = _readGatherMerge();
-	else if (MATCH("HASH", 4))
-		return_value = _readHash();
 	else if (MATCH("SETOP", 5))
 		return_value = _readSetOp();
 	else if (MATCH("LOCKROWS", 8))
diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
index c5f65934859..da30f29f94f 100644
--- a/src/backend/optimizer/path/costsize.c
+++ b/src/backend/optimizer/path/costsize.c
@@ -77,7 +77,7 @@
 #include "access/htup_details.h"
 #include "access/tsmapi.h"
 #include "executor/executor.h"
-#include "executor/nodeHash.h"
+#include "executor/nodeHashjoin.h"
 #include "miscadmin.h"
 #include "nodes/makefuncs.h"
 #include "nodes/nodeFuncs.h"
diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
index 0c036209f09..e45e0a2e253 100644
--- a/src/backend/optimizer/plan/createplan.c
+++ b/src/backend/optimizer/plan/createplan.c
@@ -223,14 +223,12 @@ static HashJoin *make_hashjoin(List *tlist,
 							   List *joinclauses, List *otherclauses,
 							   List *hashclauses,
 							   List *hashoperators, List *hashcollations,
-							   List *hashkeys,
+							   List *hashkeys_outer, List *hashkeys_inner,
+							   Oid skewTable,
+							   AttrNumber skewColumn,
+							   bool skewInherit,
 							   Plan *lefttree, Plan *righttree,
 							   JoinType jointype, bool inner_unique);
-static Hash *make_hash(Plan *lefttree,
-					   List *hashkeys,
-					   Oid skewTable,
-					   AttrNumber skewColumn,
-					   bool skewInherit);
 static MergeJoin *make_mergejoin(List *tlist,
 								 List *joinclauses, List *otherclauses,
 								 List *mergeclauses,
@@ -4376,7 +4374,6 @@ create_hashjoin_plan(PlannerInfo *root,
 					 HashPath *best_path)
 {
 	HashJoin   *join_plan;
-	Hash	   *hash_plan;
 	Plan	   *outer_plan;
 	Plan	   *inner_plan;
 	List	   *tlist = build_path_tlist(root, &best_path->jpath.path);
@@ -4501,31 +4498,8 @@ create_hashjoin_plan(PlannerInfo *root,
 	}
 
 	/*
-	 * Build the hash node and hash join node.
+	 * Build the hash join node.
 	 */
-	hash_plan = make_hash(inner_plan,
-						  inner_hashkeys,
-						  skewTable,
-						  skewColumn,
-						  skewInherit);
-
-	/*
-	 * Set Hash node's startup & total costs equal to total cost of input
-	 * plan; this only affects EXPLAIN display not decisions.
-	 */
-	copy_plan_costsize(&hash_plan->plan, inner_plan);
-	hash_plan->plan.startup_cost = hash_plan->plan.total_cost;
-
-	/*
-	 * If parallel-aware, the executor will also need an estimate of the total
-	 * number of rows expected from all participants so that it can size the
-	 * shared hash table.
-	 */
-	if (best_path->jpath.path.parallel_aware)
-	{
-		hash_plan->plan.parallel_aware = true;
-		hash_plan->rows_total = best_path->inner_rows_total;
-	}
 
 	join_plan = make_hashjoin(tlist,
 							  joinclauses,
@@ -4534,11 +4508,26 @@ create_hashjoin_plan(PlannerInfo *root,
 							  hashoperators,
 							  hashcollations,
 							  outer_hashkeys,
+							  inner_hashkeys,
+							  skewTable,
+							  skewColumn,
+							  skewInherit,
 							  outer_plan,
-							  (Plan *) hash_plan,
+							  (Plan *) inner_plan,
 							  best_path->jpath.jointype,
 							  best_path->jpath.inner_unique);
 
+	/*
+	 * If parallel-aware, the executor will also need an estimate of the total
+	 * number of rows expected from all participants so that it can size the
+	 * shared hash table.
+	 */
+	if (best_path->jpath.path.parallel_aware)
+	{
+		join_plan->join.plan.parallel_aware = true;
+		join_plan->inner_rows_total = best_path->inner_rows_total;
+	}
+
 	copy_generic_path_info(&join_plan->join.plan, &best_path->jpath.path);
 
 	return join_plan;
@@ -5577,7 +5566,11 @@ make_hashjoin(List *tlist,
 			  List *hashclauses,
 			  List *hashoperators,
 			  List *hashcollations,
-			  List *hashkeys,
+			  List *outer_hashkeys,
+			  List *inner_hashkeys,
+			  Oid skewTable,
+			  AttrNumber skewColumn,
+			  bool skewInherit,
 			  Plan *lefttree,
 			  Plan *righttree,
 			  JoinType jointype,
@@ -5593,34 +5586,16 @@ make_hashjoin(List *tlist,
 	node->hashclauses = hashclauses;
 	node->hashoperators = hashoperators;
 	node->hashcollations = hashcollations;
-	node->hashkeys = hashkeys;
-	node->join.jointype = jointype;
-	node->join.inner_unique = inner_unique;
-	node->join.joinqual = joinclauses;
-
-	return node;
-}
-
-static Hash *
-make_hash(Plan *lefttree,
-		  List *hashkeys,
-		  Oid skewTable,
-		  AttrNumber skewColumn,
-		  bool skewInherit)
-{
-	Hash	   *node = makeNode(Hash);
-	Plan	   *plan = &node->plan;
-
-	plan->targetlist = lefttree->targetlist;
-	plan->qual = NIL;
-	plan->lefttree = lefttree;
-	plan->righttree = NULL;
-
-	node->hashkeys = hashkeys;
+	node->hashkeys_outer = outer_hashkeys;
+	node->hashkeys_inner = inner_hashkeys;
 	node->skewTable = skewTable;
 	node->skewColumn = skewColumn;
 	node->skewInherit = skewInherit;
+	node->join.jointype = jointype;
+	node->join.inner_unique = inner_unique;
+	node->join.joinqual = joinclauses;
 
+	node->inner_tlist = righttree->targetlist;
 	return node;
 }
 
@@ -6763,7 +6738,6 @@ is_projection_capable_path(Path *path)
 	/* Most plan types can project, so just list the ones that can't */
 	switch (path->pathtype)
 	{
-		case T_Hash:
 		case T_Material:
 		case T_Sort:
 		case T_Unique:
@@ -6807,7 +6781,6 @@ is_projection_capable_plan(Plan *plan)
 	/* Most plan types can project, so just list the ones that can't */
 	switch (nodeTag(plan))
 	{
-		case T_Hash:
 		case T_Material:
 		case T_Sort:
 		case T_Unique:
diff --git a/src/backend/optimizer/plan/setrefs.c b/src/backend/optimizer/plan/setrefs.c
index 566ee96da8c..9e63b3a773e 100644
--- a/src/backend/optimizer/plan/setrefs.c
+++ b/src/backend/optimizer/plan/setrefs.c
@@ -107,7 +107,6 @@ static Plan *set_append_references(PlannerInfo *root,
 static Plan *set_mergeappend_references(PlannerInfo *root,
 										MergeAppend *mplan,
 										int rtoffset);
-static void set_hash_references(PlannerInfo *root, Plan *plan, int rtoffset);
 static Node *fix_scan_expr(PlannerInfo *root, Node *node, int rtoffset);
 static Node *fix_scan_expr_mutator(Node *node, fix_scan_expr_context *context);
 static bool fix_scan_expr_walker(Node *node, fix_scan_expr_context *context);
@@ -646,10 +645,6 @@ set_plan_refs(PlannerInfo *root, Plan *plan, int rtoffset)
 			}
 			break;
 
-		case T_Hash:
-			set_hash_references(root, plan, rtoffset);
-			break;
-
 		case T_Material:
 		case T_Sort:
 		case T_Unique:
@@ -1423,37 +1418,6 @@ set_mergeappend_references(PlannerInfo *root,
 	return (Plan *) mplan;
 }
 
-/*
- * set_hash_references
- *	   Do set_plan_references processing on a Hash node
- */
-static void
-set_hash_references(PlannerInfo *root, Plan *plan, int rtoffset)
-{
-	Hash	   *hplan = (Hash *) plan;
-	Plan	   *outer_plan = plan->lefttree;
-	indexed_tlist *outer_itlist;
-
-	/*
-	 * Hash's hashkeys are used when feeding tuples into the hashtable,
-	 * therefore have them reference Hash's outer plan (which itself is the
-	 * inner plan of the HashJoin).
-	 */
-	outer_itlist = build_tlist_index(outer_plan->targetlist);
-	hplan->hashkeys = (List *)
-		fix_upper_expr(root,
-					   (Node *) hplan->hashkeys,
-					   outer_itlist,
-					   OUTER_VAR,
-					   rtoffset);
-
-	/* Hash doesn't project */
-	set_dummy_tlist_references(plan, rtoffset);
-
-	/* Hash nodes don't have their own quals */
-	Assert(plan->qual == NIL);
-}
-
 /*
  * copyVar
  *		Copy a Var node.
@@ -1789,15 +1753,23 @@ set_join_references(PlannerInfo *root, Join *join, int rtoffset)
 										(Index) 0,
 										rtoffset);
 
-		/*
-		 * HashJoin's hashkeys are used to look for matching tuples from its
-		 * outer plan (not the Hash node!) in the hashtable.
-		 */
-		hj->hashkeys = (List *) fix_upper_expr(root,
-											   (Node *) hj->hashkeys,
-											   outer_itlist,
-											   OUTER_VAR,
-											   rtoffset);
+		hj->hashkeys_outer = (List *) fix_upper_expr(root,
+													 (Node *) hj->hashkeys_outer,
+													 outer_itlist,
+													 OUTER_VAR,
+													 rtoffset);
+
+		hj->hashkeys_inner = (List *) fix_upper_expr(root,
+													 (Node *) hj->hashkeys_inner,
+													 inner_itlist,
+													 INNER_VAR,
+													 rtoffset);
+
+		hj->inner_tlist = (List *) fix_upper_expr(root,
+												  (Node *) hj->inner_tlist,
+												  inner_itlist,
+												  INNER_VAR,
+												  rtoffset);
 	}
 
 	/*
diff --git a/src/backend/optimizer/plan/subselect.c b/src/backend/optimizer/plan/subselect.c
index 48b62a55de8..d1316faf183 100644
--- a/src/backend/optimizer/plan/subselect.c
+++ b/src/backend/optimizer/plan/subselect.c
@@ -2683,7 +2683,6 @@ finalize_plan(PlannerInfo *root, Plan *plan,
 			break;
 
 		case T_ProjectSet:
-		case T_Hash:
 		case T_Material:
 		case T_Sort:
 		case T_Unique:
diff --git a/src/include/executor/nodeHashjoin.h b/src/include/executor/nodeHashjoin.h
index 1752b3b208d..5ae2b535754 100644
--- a/src/include/executor/nodeHashjoin.h
+++ b/src/include/executor/nodeHashjoin.h
@@ -27,8 +27,15 @@ extern void ExecHashJoinInitializeDSM(HashJoinState *state, ParallelContext *pcx
 extern void ExecHashJoinReInitializeDSM(HashJoinState *state, ParallelContext *pcxt);
 extern void ExecHashJoinInitializeWorker(HashJoinState *state,
 										 ParallelWorkerContext *pwcxt);
-
-extern void ExecHashJoinSaveTuple(MinimalTuple tuple, uint32 hashvalue,
-								  BufFile **fileptr);
+extern void ExecHashJoinRetrieveInstrumentation(HashJoinState *node);
+extern void ExecHashJoinGetInstrumentation(HashInstrumentation *instrument,
+										   HashJoinTable hashtable);
+extern void ExecChooseHashTableSize(double ntuples, int tupwidth, bool useskew,
+									bool try_combined_work_mem,
+									int parallel_workers,
+									size_t *space_allowed,
+									int *numbuckets,
+									int *numbatches,
+									int *num_skew_mcvs);
 
 #endif							/* NODEHASHJOIN_H */
diff --git a/src/include/nodes/execnodes.h b/src/include/nodes/execnodes.h
index 44f76082e99..2e13f5a25b2 100644
--- a/src/include/nodes/execnodes.h
+++ b/src/include/nodes/execnodes.h
@@ -1924,6 +1924,30 @@ typedef struct MergeJoinState
  * ----------------
  */
 
+
+/* ----------------
+ *	 Values displayed by EXPLAIN ANALYZE
+ * ----------------
+ */
+typedef struct HashInstrumentation
+{
+	int			nbuckets;		/* number of buckets at end of execution */
+	int			nbuckets_original;	/* planned number of buckets */
+	int			nbatch;			/* number of batches at end of execution */
+	int			nbatch_original;	/* planned number of batches */
+	size_t		space_peak;		/* speak memory usage in bytes */
+} HashInstrumentation;
+
+/* ----------------
+ *	 Shared memory container for per-worker hash information
+ * ----------------
+ */
+typedef struct SharedHashInfo
+{
+	int			num_workers;
+	HashInstrumentation hinstrument[FLEXIBLE_ARRAY_MEMBER];
+} SharedHashInfo;
+
 /* these structs are defined in executor/hashjoin.h: */
 typedef struct HashJoinTupleData *HashJoinTuple;
 typedef struct HashJoinTableData *HashJoinTable;
@@ -1933,6 +1957,7 @@ typedef struct HashJoinState
 	JoinState	js;				/* its first field is NodeTag */
 	ExprState  *hashclauses;
 	List	   *hj_OuterHashKeys;	/* list of ExprState nodes */
+	List	   *hj_InnerHashKeys;	/* list of ExprState nodes */
 	List	   *hj_HashOperators;	/* list of operator OIDs */
 	List	   *hj_Collations;
 	HashJoinTable hj_HashTable;
@@ -1948,6 +1973,14 @@ typedef struct HashJoinState
 	int			hj_JoinState;
 	bool		hj_MatchedOuter;
 	bool		hj_OuterNotEmpty;
+
+	HashJoinTable hashtable;	/* hash table for the hashjoin */
+
+	SharedHashInfo *shared_info;	/* one entry per worker */
+	HashInstrumentation *hinstrument;	/* this worker's entry */
+
+	/* Parallel hash state. */
+	struct ParallelHashJoinState *parallel_state;
 } HashJoinState;
 
 
@@ -2239,46 +2272,6 @@ typedef struct GatherMergeState
 	struct binaryheap *gm_heap; /* binary heap of slot indices */
 } GatherMergeState;
 
-/* ----------------
- *	 Values displayed by EXPLAIN ANALYZE
- * ----------------
- */
-typedef struct HashInstrumentation
-{
-	int			nbuckets;		/* number of buckets at end of execution */
-	int			nbuckets_original;	/* planned number of buckets */
-	int			nbatch;			/* number of batches at end of execution */
-	int			nbatch_original;	/* planned number of batches */
-	size_t		space_peak;		/* speak memory usage in bytes */
-} HashInstrumentation;
-
-/* ----------------
- *	 Shared memory container for per-worker hash information
- * ----------------
- */
-typedef struct SharedHashInfo
-{
-	int			num_workers;
-	HashInstrumentation hinstrument[FLEXIBLE_ARRAY_MEMBER];
-} SharedHashInfo;
-
-/* ----------------
- *	 HashState information
- * ----------------
- */
-typedef struct HashState
-{
-	PlanState	ps;				/* its first field is NodeTag */
-	HashJoinTable hashtable;	/* hash table for the hashjoin */
-	List	   *hashkeys;		/* list of ExprState nodes */
-
-	SharedHashInfo *shared_info;	/* one entry per worker */
-	HashInstrumentation *hinstrument;	/* this worker's entry */
-
-	/* Parallel hash state. */
-	struct ParallelHashJoinState *parallel_state;
-} HashState;
-
 /* ----------------
  *	 SetOpState information
  *
diff --git a/src/include/nodes/nodes.h b/src/include/nodes/nodes.h
index bce2d59b0db..17fd211c0b6 100644
--- a/src/include/nodes/nodes.h
+++ b/src/include/nodes/nodes.h
@@ -80,7 +80,6 @@ typedef enum NodeTag
 	T_Unique,
 	T_Gather,
 	T_GatherMerge,
-	T_Hash,
 	T_SetOp,
 	T_LockRows,
 	T_Limit,
@@ -136,7 +135,6 @@ typedef enum NodeTag
 	T_UniqueState,
 	T_GatherState,
 	T_GatherMergeState,
-	T_HashState,
 	T_SetOpState,
 	T_LockRowsState,
 	T_LimitState,
diff --git a/src/include/nodes/plannodes.h b/src/include/nodes/plannodes.h
index 8e6594e3551..40e42716ec9 100644
--- a/src/include/nodes/plannodes.h
+++ b/src/include/nodes/plannodes.h
@@ -744,7 +744,27 @@ typedef struct HashJoin
 	 * List of expressions to be hashed for tuples from the outer plan, to
 	 * perform lookups in the hashtable over the inner plan.
 	 */
-	List	   *hashkeys;
+	List	   *hashkeys_outer;
+
+	/*
+	 * List of expressions to be hashed for tuples from inner plan, needed to
+	 * put them into the hashtable.
+	 */
+	List	   *hashkeys_inner;		/* hash keys for the hashjoin condition */
+
+	/*
+	 * If the executor is supposed to try to apply skew join optimization,
+	 * then skewTable/skewColumn/skewInherit identify the outer relation's
+	 * join key column, from which the relevant MCV statistics can be fetched.
+	 */
+	Oid			skewTable;		/* outer join key's table OID, or InvalidOid */
+	AttrNumber	skewColumn;		/* outer join key's column #, or zero */
+	bool		skewInherit;	/* is outer join rel an inheritance tree? */
+
+	double		inner_rows_total;		/* estimate total inner rows if parallel_aware */
+
+	/* XXX: explain hack */
+	List *inner_tlist;
 } HashJoin;
 
 /* ----------------
@@ -896,30 +916,6 @@ typedef struct GatherMerge
 								 * at gather merge or one of it's child node */
 } GatherMerge;
 
-/* ----------------
- *		hash build node
- *
- * If the executor is supposed to try to apply skew join optimization, then
- * skewTable/skewColumn/skewInherit identify the outer relation's join key
- * column, from which the relevant MCV statistics can be fetched.
- * ----------------
- */
-typedef struct Hash
-{
-	Plan		plan;
-
-	/*
-	 * List of expressions to be hashed for tuples from Hash's outer plan,
-	 * needed to put them into the hashtable.
-	 */
-	List	   *hashkeys;		/* hash keys for the hashjoin condition */
-	Oid			skewTable;		/* outer join key's table OID, or InvalidOid */
-	AttrNumber	skewColumn;		/* outer join key's column #, or zero */
-	bool		skewInherit;	/* is outer join rel an inheritance tree? */
-	/* all other info is in the parent HashJoin node */
-	double		rows_total;		/* estimate total rows if parallel_aware */
-} Hash;
-
 /* ----------------
  *		setop node
  * ----------------
diff --git a/src/test/regress/sql/join_hash.sql b/src/test/regress/sql/join_hash.sql
index 68c1a8c7b65..868a839719e 100644
--- a/src/test/regress/sql/join_hash.sql
+++ b/src/test/regress/sql/join_hash.sql
@@ -12,7 +12,7 @@ set local enable_hashjoin = on;
 -- general we can't make assertions about how many batches (or
 -- buckets) will be required because it can vary, but we can in some
 -- special cases and we can check for growth.
-create or replace function find_hash(node json)
+create or replace function find_hash_join(node json)
 returns json language plpgsql
 as
 $$
@@ -20,12 +20,12 @@ declare
   x json;
   child json;
 begin
-  if node->>'Node Type' = 'Hash' then
+  if node->>'Node Type' = 'Hash Join' then
     return node;
   else
     for child in select json_array_elements(node->'Plans')
     loop
-      x := find_hash(child);
+      x := find_hash_join(child);
       if x is not null then
         return x;
       end if;
@@ -45,7 +45,7 @@ begin
   for whole_plan in
     execute 'explain (analyze, format ''json'') ' || query
   loop
-    hash_node := find_hash(json_extract_path(whole_plan, '0', 'Plan'));
+    hash_node := find_hash_join(json_extract_path(whole_plan, '0', 'Plan'));
     original := hash_node->>'Original Hash Batches';
     final := hash_node->>'Hash Batches';
     return next;
-- 
2.23.0.385.gbc12974a89

